const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const bill_lines = sequelize.define(
    'bill_lines',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

description: {
        type: DataTypes.TEXT,
      
      

      },

amount: {
        type: DataTypes.DECIMAL,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  bill_lines.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity



























//end loop



    db.bill_lines.belongsTo(db.bills, {
      as: 'bill',
      foreignKey: {
        name: 'billId',
      },
      constraints: false,
    });

    db.bill_lines.belongsTo(db.chart_of_accounts, {
      as: 'expense_account',
      foreignKey: {
        name: 'expense_accountId',
      },
      constraints: false,
    });

    db.bill_lines.belongsTo(db.companies, {
      as: 'companies',
      foreignKey: {
        name: 'companiesId',
      },
      constraints: false,
    });




    db.bill_lines.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.bill_lines.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return bill_lines;
};


